import { Component, ErrorInfo, MouseEvent } from 'react';
import { IPublicModelEditor, IPublicTypeTitleContent } from '@gant-lowcode/lowcode-types';
import { PopupPipe } from '../popup';
import './index.less';
export interface FieldProps {
    className?: string;
    meta?: {
        package: string;
        componentName: string;
    } | string;
    title?: IPublicTypeTitleContent | null;
    editor?: IPublicModelEditor;
    defaultDisplay?: 'accordion' | 'inline' | 'block' | 'plain' | 'popup' | 'entry';
    collapsed?: boolean;
    valueState?: number;
    name?: string;
    tip?: any;
    onExpandChange?: (expandState: boolean) => void;
    onClear?: () => void;
}
export declare class Field extends Component<FieldProps> {
    state: {
        collapsed: boolean;
        display: "inline" | "block" | "entry" | "popup" | "accordion" | "plain";
        hasError: boolean;
    };
    private body;
    private dispose?;
    constructor(props: any);
    private toggleExpand;
    private deployBlockTesting;
    private handleClear;
    componentDidMount(): void;
    componentWillUnmount(): void;
    static getDerivedStateFromError(): {
        hasError: boolean;
    };
    componentDidCatch(error: Error, errorInfo: ErrorInfo): void;
    getTipContent(propName: string, tip?: any): any;
    clickHandler(event?: MouseEvent): void;
    render(): import("react").JSX.Element;
}
export interface PopupFieldProps extends FieldProps {
    width?: number;
}
export declare class PopupField extends Component<PopupFieldProps> {
    static contextType: import("react").Context<PopupPipe>;
    private pipe;
    static defaultProps: PopupFieldProps;
    render(): import("react").JSX.Element;
}
export interface EntryFieldProps extends FieldProps {
    stageName?: string;
}
export declare class EntryField extends Component<EntryFieldProps> {
    render(): import("react").JSX.Element;
}
export declare class PlainField extends Component<FieldProps> {
    render(): import("react").JSX.Element;
}
