import { Component, ReactElement } from 'react';
import { DockProps } from '../../types';
import { PanelDock } from '../../widget/panel-dock';
import { WidgetContainer } from '../../widget/widget-container';
import { Panel } from '../../widget/panel';
import { IWidget } from '../../widget/widget';
import './index.less';
export declare function DockView({ title, icon, description, size, className, onClick }: DockProps): import("react").JSX.Element;
export declare class PanelDockView extends Component<DockProps & {
    dock: PanelDock;
}> {
    private lastActived;
    componentDidMount(): void;
    componentDidUpdate(): void;
    checkActived(): void;
    render(): import("react").JSX.Element;
}
export declare class DialogDockView extends Component {
}
export declare class DraggableLineView extends Component<{
    panel: Panel;
}> {
    private shell;
    private defaultWidth;
    private getDefaultWidth;
    onDrag(value: number): void;
    onDragChange(type: 'start' | 'end'): void;
    render(): import("react").JSX.Element;
}
export declare class TitledPanelView extends Component<{
    panel: Panel;
    area?: string;
}> {
    private lastVisible;
    componentDidMount(): void;
    componentDidUpdate(): void;
    checkVisible(): void;
    render(): import("react").JSX.Element;
}
export declare class PanelView extends Component<{
    panel: Panel;
    area?: string;
    hideOperationRow?: boolean;
    hideDragLine?: boolean;
}> {
    private lastVisible;
    componentDidMount(): void;
    componentDidUpdate(): void;
    checkVisible(): void;
    render(): import("react").JSX.Element;
}
export declare class TabsPanelView extends Component<{
    container: WidgetContainer<Panel>;
    shouldHideSingleTab?: boolean;
}> {
    render(): import("react").JSX.Element | ReactElement<any, string | import("react").JSXElementConstructor<any>>[];
}
export declare class WidgetView extends Component<{
    widget: IWidget;
}> {
    private lastVisible;
    private lastDisabled;
    componentDidMount(): void;
    componentDidUpdate(): void;
    checkVisible(): void;
    checkDisabled(): void;
    render(): string | number | boolean | Iterable<import("react").ReactNode> | import("react").JSX.Element;
}
