"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.Workbench = void 0;
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = require("react");
var _lowcodeEditorCore = require("@gant-lowcode/lowcode-editor-core");
var _classnames = _interopRequireDefault(require("classnames"));
var _topArea = _interopRequireDefault(require("./top-area"));
var _leftArea = _interopRequireDefault(require("./left-area"));
var _leftFixedPane = _interopRequireDefault(require("./left-fixed-pane"));
var _leftFloatPane = _interopRequireDefault(require("./left-float-pane"));
var _toolbar = _interopRequireDefault(require("./toolbar"));
var _mainArea = _interopRequireDefault(require("./main-area"));
var _bottomArea = _interopRequireDefault(require("./bottom-area"));
var _rightArea = _interopRequireDefault(require("./right-area"));
require("./workbench.less");
var _context = require("../context");
var _class;
var Workbench = exports.Workbench = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_Component) {
  function Workbench(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    // 新增拖拽处理逻辑
    _this.handleSplitterMouseDown = function (e) {
      e.preventDefault();
      var startX = e.clientX;
      var startWidth = _this.state.width;
      _this.setState({
        startDrag: true
      });
      var doDrag = function doDrag(moveEvent) {
        // 计算横向移动距离并更新宽度
        var deltaX = moveEvent.clientX - startX;
        var newWidth = startWidth - deltaX;

        // 限制宽度在400px到800px之间
        _this.setState({
          width: Math.max(400, Math.min(800, newWidth))
        });
      };
      var _stopDrag = function stopDrag() {
        _this.setState({
          startDrag: false
        });
        document.removeEventListener('mousemove', doDrag);
        document.removeEventListener('mouseup', _stopDrag);
      };
      document.addEventListener('mousemove', doDrag);
      document.addEventListener('mouseup', _stopDrag);
    };
    var _this$props = _this.props,
      config = _this$props.config,
      components = _this$props.components,
      skeleton = _this$props.skeleton;
    skeleton.buildFromConfig(config, components);
    _this.state = {
      startDrag: false,
      width: 400
    };
    return _this;
  }
  (0, _inheritsLoose2["default"])(Workbench, _Component);
  var _proto = Workbench.prototype;
  _proto.render = function render() {
    var _this$props2 = this.props,
      skeleton = _this$props2.skeleton,
      className = _this$props2.className,
      topAreaItemClassName = _this$props2.topAreaItemClassName;
    return /*#__PURE__*/React.createElement("div", {
      className: (0, _classnames["default"])('lc-workbench', className)
    }, /*#__PURE__*/React.createElement(_context.SkeletonContext.Provider, {
      value: this.props.skeleton
    }, /*#__PURE__*/React.createElement("div", {
      className: "lc-workbench-body"
    }, /*#__PURE__*/React.createElement(_leftArea["default"], {
      area: skeleton.leftArea
    }), /*#__PURE__*/React.createElement(_leftFloatPane["default"], {
      area: skeleton.leftFloatArea
    }), /*#__PURE__*/React.createElement(_leftFixedPane["default"], {
      area: skeleton.leftFixedArea
    }), /*#__PURE__*/React.createElement("div", {
      className: "lc-workbench-body-right"
    }, /*#__PURE__*/React.createElement(_topArea["default"], {
      area: skeleton.topArea,
      itemClassName: topAreaItemClassName
    }), /*#__PURE__*/React.createElement("div", {
      className: "lc-workbench-splitter"
    }, /*#__PURE__*/React.createElement("div", {
      className: "lc-workbench-center left-area-splitter-panel"
    }, /*#__PURE__*/React.createElement(_toolbar["default"], {
      area: skeleton.toolbar
    }), /*#__PURE__*/React.createElement(_mainArea["default"], {
      area: skeleton.mainArea
    }), /*#__PURE__*/React.createElement(_bottomArea["default"], {
      area: skeleton.bottomArea
    })), /*#__PURE__*/React.createElement("div", {
      className: "splitter-bar",
      onMouseDown: this.handleSplitterMouseDown
    }, /*#__PURE__*/React.createElement("div", {
      className: "splitter-bar-dragger"
    })), /*#__PURE__*/React.createElement("div", {
      className: "right-area-splitter-panel",
      style: {
        width: this.state.width
      }
    }, /*#__PURE__*/React.createElement(_rightArea["default"], {
      area: skeleton.rightArea
    })), this.state.startDrag && /*#__PURE__*/React.createElement("div", {
      "aria-hidden": true,
      className: "splitter-mask"
    })))), /*#__PURE__*/React.createElement(_lowcodeEditorCore.TipContainer, null)));
  };
  return Workbench;
}(_react.Component)) || _class;